################################################################################
#                                  WARMOD                                      #
################################################################################
################################################################################
# USAGE INSTRUCTIONS                                                           #
################################################################################
# to start a war, send the command                                             #
# war "t team name" "ct team name"                                             #
# via rcon, for example:                                                       #
# rcon war "Randoms" "Example"                                                 #
# will start a war between randoms and examples, with randoms starting on t's  #
################################################################################
# to cancel a war, simply rcon the command                                     #
# war_cancel                                                                   #
# eg/                                                                          #
# ma_rcon war_cancel                                                           #
# rcon war_cancel                                                              #
################################################################################
# At halftime, the war will "pause" to allow competitors to talk before        #
# resuming the next half. to resume the war, rcon the command                  #
# war_resume                                                                   #
# es/                                                                          #
# rcon war_resume                                                              #
################################################################################
# any player, at anytime can check the score by saying                         #
# !score                                                                       #
################################################################################
################################################################################



import es, playerlib, gamethread


info = es.AddonInfo()
info.name     = "Warmod"
info.version  = "1.0"
info.url      = "http://addons.eventscripts.com/addons/view/warmod"
info.basename = "warmod"
info.author   = "Impact | Master"
es.ServerVar('warmod_ver', info.version, 'Warmod, by Impact | Master').makepublic()


global war
war = {
'active': 0,
'team1': 0,
'score1': 0,
'team2': 0,
'score2': 0,
'swap': 0,
'roundno': 0,
'overtime': 0,
'ot_count': 0
}


def load():
    es.regcmd('war', 'warmod/start', 'Start a war')
    es.regcmd('war_cancel', 'warmod/war_cancel', 'Cancel war')
    es.regcmd('war_resume', 'warmod/war_resume', 'Resume a war after halftime')
    es.regsaycmd('!score', 'warmod/say_score', 'Get the current score')
    
def start():
    global war
    war = {
    'active': 0,
    'team1': 0,
    'score1': 0,
    'team2': 0,
    'score2': 0,
    'swap': 0,
    'roundno': 0,
    'overtime': 0,
    'ot_count': 0
    }
    war['team1'] = es.getargv(1)
    war['team2'] = es.getargv(2)
    es.msg("#multi", "#green [WarMod] #lightgreen Starting war between %s and %s" %(war['team1'], war['team2']))
    es.msg("#multi", "#green [WarMod] #lightgreen Everything is automatic -- Including team change")
    do_lo3()
        
def round_end(event_var):
    global war
    if war['active'] == 1:
    
        war['roundno'] += 1

        
        if war['roundno'] <=15:
            #Team 1 are T's      
            if event_var['winner'] == "2":
                war['score1'] += 1
            elif event_var['winner'] == "3":
                war['score2'] += 1
        else:
            #team 1 are CT's
            if event_var['winner'] == "2":
                war['score2'] += 1
            elif event_var['winner'] == "3":
                war['score1'] += 1
    
        do_score()
        if war['roundno'] == 15:
            if war['swap'] == 0:
                es.msg("#multi", "#green [WarMod] #lightgreen End of section 1")
                es.delayed(1, "es_doblock warmod/swap_teams")
                war['active'] = 0
    
        if war['score1'] == 16:
            es.msg("#multi", "#green [WarMod] #lightgreen End of war - %s wins!" %(war['team1']))
            es.msg("#multi", "#green [WarMod] #lightgreen Final Score was %s - %s" %(war['score1'], war['score2']))
            war['active'] = 0
        elif war['score2'] == 16:
            es.msg("#multi", "#green [WarMod] #lightgreen End of war - %s wins!" %(war['team2']))
            es.msg("#multi", "#green [WarMod] #lightgreen Final Score was %s - %s" %(war['score2'], war['score1']))
            war['active'] = 0
            
        if war['score1'] == 15 & war['score2'] == 15:
            es.msg("#multi", "#green [WarMod] #lightgreen 15 -15 lock!")
            es.msg("#multi", "#green [WarMod] #lightgreen War is going into OVERTIME")
            war['ot_count'] += 1
            war['active'] = 0
            war['swap'] = 0
            war['overtime'] = 0
            war['score1'] = 0
            war['score2'] = 0
            war['roundno'] = 0
            do_ot_lo3()
            
    elif war['overtime'] == 1:
        ##overtime_re()
        war['roundno'] += 1
        if war['roundno'] <=3:
            if event_var['winner'] == "2":
                war['score2'] += 1
            elif event_var['winner'] == "3":
                war['score1'] += 1
        else: 
            if event_var['winner'] == "2":
                war['score1'] += 1
            elif event_var['winner'] == "3":
                war['score2'] += 1
        do_score()
        if war['roundno'] == 3:
            if war['swap'] == 0:
                es.delayed(1, "es_doblock warmod/ot_swap_teams")
                war['overtime'] = 0
    
        if war['score1'] == 4:
                es.msg("#multi", "#green [WarMod] #lightgreen End of war - %s wins!" %(war['team1']))
                es.msg("#multi", "#green [WarMod] #lightgreen Overtime score was %s - %s" %(war['score1'], war['score2']))
                war['overtime'] = 0
        elif war['score2'] == 4:
                es.msg("#multi", "#green [WarMod] #lightgreen End of war - %s wins!" %(war['team2']))
                es.msg("#multi", "#green [WarMod] #lightgreen Overtime score was %s - %s" %(war['score2'], war['score1']))
                war['overtime'] = 0
    
        if war['score1'] == 3 & war['score2'] == 3:
            es.msg("#multi", "#green [WarMod] #lightgreen 3 - 3 lock!")
            war['ot_count'] += 1
            es.msg("#multi", "#green [WarMod] #lightgreen War is going into %sxOVERTIME" %(war['ot_count']))
            war['active'] = 0
            war['swap'] = 0
            war['overtime'] = 0
            war['score1'] = 0
            war['score2'] = 0
            war['roundno'] = 0
            do_ot_lo3()
            ####################################
def do_lo3():
    global war
    for i in range(0, 6):
          es.delayed(3, "es_msg #multi #green [WarMod] #lightgreen  Live on 3 restarts")
    es.delayed(4, "mp_restartgame 1")
    for i in range(0, 6):
          es.delayed(5, "es_msg #multi #green [WarMod] #lightgreen  Live on 2 restarts")
    es.delayed(6, "mp_restartgame 1")
    for i in range(0, 6):
          es.delayed(7, "es_msg #multi #green [WarMod] #lightgreen  Live Next Restart!!!")
    es.delayed(6, "mp_restartgame 3")
    
    es.delayed(12, "es_doblock warmod/activate")
    
    es.delayed(9, "es_msg #multi #green [WarMod] #lightgreen  *LIVE*------")
    es.delayed(9.1, "es_msg #multi #green [WarMod] #lightgreen  -*LIVE*-----")
    es.delayed(9.2, "es_msg #multi #green [WarMod] #lightgreen  --*LIVE*----")
    es.delayed(9.3, "es_msg #multi #green [WarMod] #lightgreen  ---*LIVE*---")
    es.delayed(9.4, "es_msg #multi #green [WarMod] #lightgreen  ----*LIVE*--")
    es.delayed(9.5, "es_msg #multi #green [WarMod] #lightgreen  -----*LIVE*-")
    es.delayed(9.6, "es_msg #multi #green [WarMod] #lightgreen  ------*LIVE*")
    es.delayed(9.7, "es_msg #multi #green [WarMod] #lightgreen  -----*LIVE*-")
    es.delayed(9.8, "es_msg #multi #green [WarMod] #lightgreen  ----*LIVE*--")
    es.delayed(9.9, "es_msg #multi #green [WarMod] #lightgreen  ---*LIVE*---")
    es.delayed(10, "es_msg #multi #green [WarMod] #lightgreen  --*LIVE*----")
    es.delayed(10.1, "es_msg #multi #green [WarMod] #lightgreen  -*LIVE*-----")
    es.delayed(10.2, "es_msg #multi #green [WarMod] #lightgreen  *LIVE*------")
    es.delayed(10.3, "es_msg #multi #green [WarMod] #lightgreen  *LIVE*------")
    es.delayed(10.4, "es_msg #multi #green [WarMod] #lightgreen  -*LIVE*-----")
    es.delayed(10.5, "es_msg #multi #green [WarMod] #lightgreen  --*LIVE*----")
    es.delayed(10.6, "es_msg #multi #green [WarMod] #lightgreen  ---*LIVE*---")
    es.delayed(10.7, "es_msg #multi #green [WarMod] #lightgreen  ----*LIVE*--")
    es.delayed(10.8, "es_msg #multi #green [WarMod] #lightgreen  -----*LIVE*-")
    es.delayed(10.9, "es_msg #multi #green [WarMod] #lightgreen  ------*LIVE*")
    es.delayed(11, "es_msg #multi #green [WarMod] #lightgreen  -----*LIVE*-")
    es.delayed(11.1, "es_msg #multi #green [WarMod] #lightgreen  ----*LIVE*--")
    es.delayed(11.2, "es_msg #multi #green [WarMod] #lightgreen  ---*LIVE*---")
    es.delayed(11.3, "es_msg #multi #green [WarMod] #lightgreen  ---*LIVE*---")
    es.delayed(11.4, "es_msg #multi #green [WarMod] #lightgreen  ---*LIVE*---")
    es.delayed(11.5, "es_msg #multi #green [WarMod] #lightgreen  ---*LIVE*---")
    es.delayed(11.5, "es_msg #multi #green [WarMod] #lightgreen  ---*LIVE*---")
    es.delayed(11.6, "es_msg #multi #green [WarMod] #lightgreen  Good Luck! Have Fun!")
        
def swap_teams():
    global war
    war['swap'] = 1
    es.msg("#multi", "#green [WarMod] #lightgreen Swapping teams...")
    ctlist = playerlib.getPlayerList('#ct')
    tlist = playerlib.getPlayerList('#t')
    for player in ctlist:
        es.changeteam(player.userid, '2')
    for player in tlist:
        es.changeteam(player.userid, '3')
    ctlist = None
    tlist = None
    #####################################################
    
def round_start(event_var):
    global war
    if war['active'] == 1:
        pList = playerlib.getPlayerList('#ct')
        for player in pList:
            cash = es.getplayerprop(player.userid, "CCSPlayer.m_iAccount")
            name = es.getplayername(player.userid)
            for tm in pList:
                if tm.userid != player.userid:
                    es.tell(tm.userid, "#multi", "#green [$$] #default %s #green >> #lightgreen $%s" %(name, cash))
        pList = playerlib.getPlayerList('#t')
        for player in pList:
            cash = es.getplayerprop(player.userid, "CCSPlayer.m_iAccount")
            name = es.getplayername(player.userid)
            for tm in pList:
                if tm.userid != player.userid:
                    es.tell(tm.userid, "#multi", "#green [$$] #default %s #green >> #lightgreen $%s" %(name, cash))
        pList = None
    
 
def do_score():
    global war
    if war['score1'] > war['score2']:
        es.msg("#multi", "#green [WarMod] #lightgreen End of round %s -- %s leads %s - %s" %(war['roundno'], war['team1'], war['score1'], war['score2']))
    elif war['score1'] < war['score2']:
        es.msg("#multi", "#green [WarMod] #lightgreen End of round %s -- %s leads %s - %s" %(war['roundno'], war['team2'], war['score2'], war['score1']))
    elif war['score1'] == war['score2']:
        es.msg("#multi", "#green [WarMod] #lightgreen End of round %s -- Game is tied %s all" %(war['roundno'], war['score2']))

def activate():
    global war
    war['active'] = 1
    
def war_cancel():
    global war
    userid = es.getcmduserid()
    steam = es.getplayersteamid(userid)
    admin = es.keygetvalue("members", steam, "admin")    
    if admin == "1":
        war = {
        'active': 0,
        'team1': 0,
        'score1': 0,
        'team2': 0,
        'score2': 0,
        'swap': 0,
        'roundno': 0
        }
        es.msg("#multi", "#green [WarMod] #lightgreen War has been ended by admin")
    else:
        es.tell(userid, "#multi", "#green [WarMod] #lightgreen You are not authorised to start a war")
        
def do_ot_lo3():
    global war
    for i in range(0, 6):
          es.delayed(3, "es_msg #multi #green [WarMod] #lightgreen  Overtime in 3 restarts")
    es.delayed(4, "mp_restartgame 1")
    for i in range(0, 6):
          es.delayed(5, "es_msg #multi #green [WarMod] #lightgreen  Overtime in 2 restarts")
    es.delayed(6, "mp_restartgame 1")
    for i in range(0, 6):
          es.delayed(7, "es_msg #multi #green [WarMod] #lightgreen  Overtime Next Restart!!!")
    es.delayed(6, "mp_restartgame 3")
    
    es.delayed(12, "es_doblock warmod/overtime_start")
    
    es.delayed(9, "es_msg #multi #green [WarMod] #lightgreen  *!OT!*------")
    es.delayed(9.1, "es_msg #multi #green [WarMod] #lightgreen  -*!OT!*-----")
    es.delayed(9.2, "es_msg #multi #green [WarMod] #lightgreen  --*!OT!*----")
    es.delayed(9.3, "es_msg #multi #green [WarMod] #lightgreen  ---*!OT!*---")
    es.delayed(9.4, "es_msg #multi #green [WarMod] #lightgreen  ----*!OT!*--")
    es.delayed(9.5, "es_msg #multi #green [WarMod] #lightgreen  -----*!OT!*-")
    es.delayed(9.6, "es_msg #multi #green [WarMod] #lightgreen  ------*!OT!*")
    es.delayed(9.7, "es_msg #multi #green [WarMod] #lightgreen  -----*!OT!*-")
    es.delayed(9.8, "es_msg #multi #green [WarMod] #lightgreen  ----*!OT!*--")
    es.delayed(9.9, "es_msg #multi #green [WarMod] #lightgreen  ---*!OT!*---")
    es.delayed(10, "es_msg #multi #green [WarMod] #lightgreen  --*!OT!*----")
    es.delayed(10.1, "es_msg #multi #green [WarMod] #lightgreen  -*!OT!*-----")
    es.delayed(10.2, "es_msg #multi #green [WarMod] #lightgreen  *!OT!*------")
    es.delayed(10.3, "es_msg #multi #green [WarMod] #lightgreen  *!OT!*------")
    es.delayed(10.4, "es_msg #multi #green [WarMod] #lightgreen  -*!OT!*-----")
    es.delayed(10.5, "es_msg #multi #green [WarMod] #lightgreen  --*!OT!*----")
    es.delayed(10.6, "es_msg #multi #green [WarMod] #lightgreen  ---*!OT!*---")
    es.delayed(10.7, "es_msg #multi #green [WarMod] #lightgreen  ----*!OT!*--")
    es.delayed(10.8, "es_msg #multi #green [WarMod] #lightgreen  -----*!OT!*-")
    es.delayed(10.9, "es_msg #multi #green [WarMod] #lightgreen  ------*!OT!*")
    es.delayed(11, "es_msg #multi #green [WarMod] #lightgreen  -----*!OT!*-")
    es.delayed(11.1, "es_msg #multi #green [WarMod] #lightgreen  ----*!OT!*--")
    es.delayed(11.2, "es_msg #multi #green [WarMod] #lightgreen  ---*!OT!*---")
    es.delayed(11.3, "es_msg #multi #green [WarMod] #lightgreen  ---*!OT!*---")
    es.delayed(11.4, "es_msg #multi #green [WarMod] #lightgreen  ---*!OT!*---")
    es.delayed(11.5, "es_msg #multi #green [WarMod] #lightgreen  ---*!OT!*---")
    es.delayed(11.5, "es_msg #multi #green [WarMod] #lightgreen  ---*!OT!*---")
    es.delayed(11.6, "es_msg #multi #green [WarMod] #lightgreen  Good Luck! Have Fun!")
    
def overtime_start():
    global war
    war['overtime'] = 1

def ot_swap_teams():
    global war
    war['swap'] = 1
    es.msg("#multi", "#green [WarMod] #lightgreen Swapping teams...")
    ctlist = playerlib.getPlayerList('#ct')
    tlist = playerlib.getPlayerList('#t')
    for player in ctlist:
        es.changeteam(player.userid, '2')
    for player in tlist:
        es.changeteam(player.userid, '3')
    ctlist = None
    tlist = None
    do_ot_lo3()
    
def war_resume():
    es.msg("#multi", "#green [WarMod] #lightgreen War is Resuming!")
    do_lo3()

def say_score():
    global war
    if war['active'] == 1:
        userid = es.getcmduserid()
        if war['score1'] > war['score2']:
            es.tell(userid, "#multi", "#green [WarMod] #lightgreen %s leads %s - %s" %(war['team1'], war['score1'], war['score2']))
        elif war['score1'] < war['score2']:
            es.tell(userid, "#multi", "#green [WarMod] #lightgreen %s leads %s - %s" %(war['team2'], war['score2'], war['score1']))
        elif war['score1'] == war['score2']:
            es.tell(userid, "#multi", "#green [WarMod] #lightgreen Tie! %s all" %(war['score1']))
    elif war['overtime'] == 1:
        userid = es.getcmduserid()
        if war['score1'] > war['score2']:
            es.tell(userid, "#multi", "#green [WarMod] #lightgreen %s leads %s - %s" %(war['team1'], war['score1'], war['score2']))
        elif war['score1'] < war['score2']:
            es.tell(userid, "#multi", "#green [WarMod] #lightgreen %s leads %s - %s" %(war['team2'], war['score2'], war['score1']))
        elif war['score1'] == war['score2']:
            es.tell(userid, "#multi", "#green [WarMod] #lightgreen Tie! %s all" %(war['score1']))